#include <stdlib.h>     /* srand, rand */
#include "Card.h"


const String SUIT[SUIT_MAX] = { "D", "H", "S", "C" };
const String RANK[RANK_MAX] = { "7", "8", "9", "K", "T", "A", "J", "Q" };
const int POINTS[RANK_MAX] = { 0, 0, 0, 4, 10, 11, 2, 3 };
const String TRUMP[TRUMP_MAX] = { "7D", "8D", "9D", "KD", "TD", "AD", "JD", "JH", "JS", "JC", "QD", "QH", "QS", "QC" };

Card::Card()
{
	_suit = NOT_SET;
	_rank = NOT_SET;
	_points = 0;

}

Card::Card(const int &suit, const int &rank) : _suit(suit), _rank(rank)
{

}


String Card::Card2Str() const
{
	if (getRank() >= 0 && getSuit() >= 0) {
		return RANK[getRank()] + SUIT[getSuit()];
	}
	return "NA";
}


int Card::getPoints() const
{
	if (getRank() >= 0) {
		return POINTS[getRank()];
	}
	return 0;
}


int Card::getSuit() const
{
	return _suit;
}

int Card::getRank() const
{
	return _rank;
}


int Card::getPoints(String cardId) {
	String rank = cardId.substring(0, 1);
	for (int i = 0; i < RANK_MAX; i++) {
		Serial.print("Rank = ");
		Serial.print(rank);
		Serial.print(" ?=? ");
		Serial.println(RANK[i]);
		if (rank.compareTo(RANK[i]) == 0) {
			return POINTS[i];
		}
	}
	return 0;
}


int Card::cardRank(char leadsuit, String cardId) {
	if (cardId.charAt(1) != leadsuit) {
		return -1;
	}
	else {
		for (int i = 0; i < RANK_MAX; i++) {
			if (cardId.charAt(0) == RANK[i].charAt(0)) {
				return i;
			}
		}
	}
	// Should not happen unless major error
	return -2;
}