//#include <iostream>
#include <time.h>
#include "Deck.h"


Deck::Deck()
{
	int index = 0;
	for (unsigned int i = 0; i < SUIT_MAX; i++)
	{
		for (unsigned int j = 0; j < RANK_MAX; j++)
		{
			Card card(i, j);
			_deck[index++] = card;
		}
	}
}


void Deck::printDeck() const
{
	unsigned int count = 0; // (1);

	for (unsigned int i = 0; i < MAX_CARDS; i++)
	{
		Serial.print(_deck[i].Card2Str());
		if (count == 8)
		{
			Serial.println();
			count = 0;
		}
		++count;
	}
}

Card * Deck::getOneCard()
{
	return &_deck[--_cardindex];
}


void Deck::shuffle()
{
	long seed = ESP.getCycleCount();
	Serial.print("RANDOM SEED = (");
	Serial.print(seed);
	Serial.println(")");

	randomSeed(seed);
	int cycle = getRandonNumber(251, 321);

	for (int i = 1; i <= cycle; i++)
	{
		for (int j = 0; j < MAX_CARDS; j++)
		{
			int n = getRandonNumber(0, 320) % 32;
			Card tempCard = _deck[j];
			_deck[j] = _deck[n];
			_deck[n] = tempCard;
		}
	}

	// Reset the card Index after each shuffle
	_cardindex = MAX_CARDS;
}
int Deck::getRandonNumber(int start, int end) {
	randomSeed(ESP.getCycleCount());
	return random(start, end);
}