#pragma once

#include "Card.h"
#include <WString.h>
#define MAX_PLAYER_CARDS 12

class Player
{
public:
	Player();
	Player(String);
	void setCard(Card *);
	void updateCardById(int id, int handPlayed);
	void updateCardPlayed(String, int);
	String findCardNameByHand(int);

	void printHand();
	String getHandJSON();
	String getName();
	int getNumCards();
	void resetNumCards();
	bool getActive();

	void setName(String);
	void setActive(bool);

	bool getPassed();
	void setPassed(bool);

	bool getPicked();
	void setPicked(bool);
	String getPlayerMsg();
	void setPlayerMsg(int);

	void setPoints(int);
	void addPoints(int);
	void addPoints(String);
	int getPoints();

	void setTeamPoints(int);
	void addTeamPoints(int);
	int getTeamPoints();

private:
	String _name;
    Card * _cards[MAX_PLAYER_CARDS];
	int _handplayed[MAX_PLAYER_CARDS];
	int _cardplayed[MAX_PLAYER_CARDS];
	int _numberofcards;
	bool _active;
	bool _passed;
	bool _picked;
	int _points;
	int _teampoints;
	String _playermessage;
};

