$.ajaxSetup({
    cache: false
});
var pid = -1;
var pname = "";
var jsonTimer = null;
var startGame = false;
var json;

$(function () {
    getStatus();
});

function getStatus() {
    $.getJSON("login.json",
	function (data) {
	    json = data;
	    console.log("In getJSON() call " + data);
	    var maxPlayers = data.maxPlayers;
	    var numPlayers = data.numPlayers;
	    console.log("Number", data.hasOwnProperty("pid"));
	    pid = data.pid;
	    if (pid >= 0) {
	        pname = data.pname;
	        $(".user #quit").show();
	        $(".user #join").hide();
	        $(".user input[name='playername']").prop('disabled', true);
	        $(".user input[name='playername']").val(data.pname);
	    }
	    else {
	        $(".user #join").show();
	        $('#username').keypress(function (event) {
	            if (event.keyCode == 13) {
	                $(".user #join").click();
	            }
	        });
	        $(".user #quit").hide();
	        $(".user input[name='playername']").prop('disabled', false);
	    }
	    $("div#msg").html(data.playerMessage);
	    console.log("numPlayers = " + numPlayers + ", pid = " + pid
				+ ", maxPlayers = " + maxPlayers);
	    if (numPlayers == maxPlayers) {
	        $(".user #start").show();
	    } else {
	        $(".user #start").hide();
	    }
	    updatePlayers(data.players);
	});
    if (!startGame) {
        jsonTimer = setTimeout(getStatus, 5000);
    }
}

function updatePlayers(json) {
    $('.players li').remove();
    $.each(json, function (index, player) {
        $('.players').append(
				"<li id='P" + index + "_name'>" + player.name + "</li>");
    });
};

$(".user button#join").click(function () {
    var pname = $(".user input[name='playername']").val();
    var nPlayers = $(".mode input[type='Radio']:checked").val();
    $.post("/join", {
        USERNAME: pname,
        NPLAYERS: nPlayers
    });
});

$(".user button#quit").click(function () {
    var pname = $(".user input[name='playername']").val();
    $.post("/quit", {
        DISCONNECT: pname,
        SESSIONID: pid
    });
});

$(".user button#start").click(function () {
    clearTimeout(jsonTimer);
    startGame = true;
    var pname = $(".user input[name='playername']").val();

    $.post("/start", {
        USERNAME: pname,
        SESSIONID: pid
    }, function (data) {
        $(location).attr('href', "/sheepshead");
    });
});


