// Create namespace
var CardUtil = {};

var TRUMP = ['7D', '8D', '9D', 'KD', 'TD', 'AD', 'JD', 'JH', 'JS', 'JC', 'QD',
		'QH', 'QS', 'QC'];
var CLUB = ['7C', '8C', '9C', 'KC', 'TC', 'AC'];
var SPADE = ['7S', '8S', '9S', 'KS', 'TS', 'AS'];
var HEART = ['7H', '8H', '9H', 'KH', 'TH', 'AH'];

var cardValue = ['7H', '7S', '7C', '8H', '8S', '8C', '9H', '9S', '9C', 'KH',
		'KS', 'KC', 'TH', 'TS', 'TC', 'AH', 'AS', 'AC', '7D', '8D', '9D', 'KD',
		'TD', 'AD', 'JD', 'JH', 'JS', 'JC', 'QD', 'QH', 'QS', 'QC'];
var cardPoints = [0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 10, 10, 10, 11, 11, 11,
		0, 0, 0, 4, 10, 11, 2, 2, 2, 2, 3, 3, 3, 3];

var NOT_SET = "?";
var LOGIN = 0;
var DEAL = 1;
var START = 2;
var PICKING = 3;
var HAND = 4;
var CONFIRM = 5;
var HWINNER = 6;
var GWINNER = 7;
var END = 8;

var json;
var Message;

// Inital load of data or a page refresh
function showHand() {
    $.ajax({
        url: "player.json",
        dataType: "json",
        success: loadJSON
    });

    $(function () {
        showStats();
    });
}

function loadJSON(myjson) {

    console.log(myjson);

    json = myjson;

    $("#playerid").val(json.pid);

    $.each(json.players, function (i) {
        var pList = $(".sidebar");
        var li = $('<li/>').addClass("player").attr("id", "P" + i).insertBefore(pList);

        var ul = $('<ul/>').appendTo(li);
        var li2 = $('<li/>').attr('id', "P" + i + "_name").text(json.players[i].name).appendTo(ul);
        var li3 = $('<li/>').appendTo(ul);
        var img = $('<img/>').attr({ id: "P" + i + "_img", src: "img/cards/" + json.players[i].card + ".png" }).appendTo(li3);

        var li4 = $('<li/>').addClass("action").attr('id', "P" + i + "_action").text(json.players[i].message).appendTo(ul);
    });


    // update the blind cards
    $.each(json.blind, function (i) {
        var bList = $("#blind");
        var index = i + json.numplaycrd;
        var li = $('<li/>').attr("id", "card_" + index).appendTo(bList);
        var img = $('<img/>').attr({ onclick: "cardClick(" + index + ");", src: "img/cards/back.png" }).appendTo(li);
    });

    // Update the cards
    $.each(json.mycards, function (i) {
        var cList = $("#my_cards");
        var li = $('<li/>').attr("id", "card_" + i).appendTo(cList);
        var img = $('<img/>').attr({ onclick: "cardClick(" + i + ");", src: "img/cards/" + json.mycards[i].card + ".png" }).appendTo(li);
    });

    if (json.state == PICKING) {
        $(".sidebar .userdata").hide();
        $(".myButtons .nextHand").hide();
        $(".myButtons .pick").show();
        $(".myButtons .pass").show();
    }
    else {
        $(".sidebar .userdata").show();
    }

    if ((myjson.pid == myjson.turn) && (json.state == HAND) && (json.hwinid >= 0)) {
        $(".myButtons .nextHand").show();
    }

    // Set border color for whose turn it is
    $(".player#P" + json.turn).css("border", "2px solid red");

    // Set the players name to red
    $("#P" + json.pid + "_name").css("color", "white")

    if (myjson.state == GWINNER) {
        $(".myButtons .nextHand").html("New game");
        $(".myButtons .nextHand").attr('onClick', 'gameEnd();');
        $(".myButtons .nextHand").show();

        // Stop the timer so page is not updated
        clearTimeout(timer);
    }

    // Hide the called suit for 3 and 4 handed
    if (json.players.length != 5) {
        $("#calledsuitDD").hide();
        $(".calledsuit").hide();
        $(".partner").hide();
    }
    else {
        $("#calledsuitDD").show();
        $(".calledsuit").show();
        $(".partner").show();
    }

    dragAndDrop.init();
}

function showStats() {
    $.ajax({
        url: "gamestats.json",
        dataType: "json",
        success: loadStats
    });
    timer = setTimeout(showStats, 3000);
}

function loadStats(myjson) {

    if (myjson.pid == myjson.turn) {
        clearTimeout(timer);
    }

    json.csuit = myjson.csuit;
    json.tpoints = myjson.tpoints;
    json.hwin = myjson.hwin;
    json.hwinid = myjson.hwinid;
    json.gwin = myjson.gwin;
    json.points = myjson.points;
    json.turn = myjson.turn;
    json.picker = myjson.picker;
    json.passed = myjson.passed;
    json.picked = myjson.picked;
    json.partner = myjson.partner;
    json.message = myjson.message;
    json.state = myjson.state;
    json.players = myjson.players;
    json.pid = myjson.pid;
    json.lsuit = myjson.lsuit;

    $("#playerid").val(json.pid);

    $("#calledsuit").html(json.csuit);
    $("#teampoints").html(json.tpoints);
    $("#handwinner").html(json.hwin);
    $("#gamewinner").html(json.gwin);
    $("#mypoints").html(json.points);
    $("#picker").html(json.picker);
    $("#partner").html(json.partner);
    $(".messageArea").html(json.message);

    // Turn off border color
    if (json.players.length) {
        for (var i = 0; i < json.players.length; i++) {
            $(".player#P" + i).css("border", "0px");
        }
    }

    // Set border color for whose turn it is
    $(".player#P" + json.turn).css("border", "2px solid red");
    // Set the players name to white
    $("#P" + json.pid + "_name").css("color", "white")


    if (json.state == PICKING && json.passed == 0) {
        $(".sidebar .userdata").hide();
        $(".myButtons .pick").show();
        $(".myButtons .pass").show();
    }
    else {
        $("#blindData").hide();
        $(".myButtons .pick").hide();
        $(".myButtons .pass").hide();
        $(".myButtons .nextHand").hide();
        $(".sidebar .userdata").show();
    }


    if ((myjson.pid == myjson.turn) && (json.state == CONFIRM) && (json.hwinid >= 0)) {
        $(".myButtons .nextHand").show();
    }
    else {
        $(".myButtons .nextHand").hide();
    }

    if (myjson.state == GWINNER) {
        $(".myButtons .nextHand").html("New game");
        $(".myButtons .nextHand").attr('onClick', 'gameEnd();');
        $(".myButtons .nextHand").show();

        // Stop the timer so page is not updated
        clearTimeout(timer);
    }

    if (json.players.length == 3) {
        $("#calledsuitDD").hide();
        $(".calledsuit").hide();
        $(".partner").hide();
    }

    var players = myjson.players;
    for (var i = 0; i < players.length; i++) {
        $("#P" + i + "_name").html(players[i].name);

        // Uplate the card
        $("#P" + i + " li #P" + i + "_img").attr("src", "img/cards/" + players[i].card + ".png");

        // Update player message
        $("#P" + i + " .action").html(players[i].message);

        json.players[i].card = players[i].card;
        json.players[i].message = players[i].message;
    }

}



function theCardToPlay(cardValue) {
    var card = NOT_SET;
    function setCard(value) {
        console.log("set card = " + card);
        console.log("setCard's cardValue = (" + value + ")");
        if ((value == NOT_SET) || !isNaN(value)) {
            card = value;
        }
        console.log("card = (" + card + ")");
        return card;
    }

    return setCard;
};
var cardToPlay = theCardToPlay(NOT_SET);

function playCard(id) {

    console.log("playCard id = " + id);

    // POST which cards was played
    var data = { "pid": json.pid, "cardPlayed": json.mycards[id].card };
    $.post("/playCard", $.param(data))
		.done(function (data) {

		    var parent = document.getElementById("my_cards");
		    var el = document.getElementById("card_" + id);
		    el.firstChild.src = "";
		    el.firstChild.style["WebkitTransform"] = "scale(1.0)";
		    el.firstChild.onclick = "";
		    parent.removeChild(el);

		    // Move card to play area
		    var el2 = document.getElementById("P" + json.pid + "_img");
		    el2.src = "img/cards/" + json.mycards[id].card + ".png";

		    document.getElementById("P" + json.pid + "_action").innerHTML = "Played";

		    // The card was played, turn on the json refresh
		    showStats();
		});

}

// flip over card and check for match of lead suit
function showCard(id) {

    console.log("showCard id = " + id);

    if (json.lsuit == "C") {
        myArray = CLUB;
    }
    else if (json.lsuit == "S") {
        myArray = SPADE;
    }
    else if (json.lsuit == "H") {
        myArray = HEART;
    }
    else if (json.lsuit == "T") {
        myArray = TRUMP;
    }

    // assume the card is valid but check
    var valid = true;
    var cardArray = $("#my_cards li img").map(function () { return $(this).attr("src"); }).get();
    if (json.lsuit != "N") {
        if ($.inArray(json.mycards[id].card, myArray) >= 0) {
            // if its the lead suit it is valid so far
            valid = true;
        }
        else {
            // look through all cards to see if the called suit is available
            $.each(cardArray, function (i) {
                var fileNameIndex = cardArray[i].lastIndexOf("/") + 1;
                var filename = cardArray[i].substr(fileNameIndex).slice(0, -4);
                if ($.inArray(filename, myArray) >= 0) {
                    valid = false;
                }
            });
        }

        if (!valid) {
            setTimeout(function () {
                $(".messageArea").html("");
            }, 3000);
            $(".messageArea").html("Must play the lead suit");
            return;
        }

        // if the lead suit is the called suit the player must play the ace if they have it.
        if (json.lsuit == json.callsuit) {
            if (json.mycards[id].card == myArray[5]) {
                // if it is the Ace of the called suit it is valid
                valid = true;
            }
            else {
                // Check if the player has the Ace
                $.each(cardArray, function (i) {
                    var fileNameIndex = cardArray[i].lastIndexOf("/") + 1;
                    var filename = cardArray[i].substr(fileNameIndex).slice(0, -4);
                    if (filename == myArray[5]) {
                        valid = false;
                    }
                });
            }
        }

        if (!valid) {
            setTimeout(function () {
                $(".messageArea").html("");
            }, 3000);
            $(".messageArea").html("Must play Ace of called suit");
            return;
        }

    }
    var el = document.getElementById("card_" + id);
    el.firstChild.src = "img/cards/" + json.mycards[id].card + ".png";
    el.firstChild.style["WebkitTransform"] = "scale(1.2)";

    console.log("card id = " + cardToPlay());
    if (cardToPlay() == id) {
        setTimeout("playCard(" + cardToPlay() + ");", 1000);
        cardToPlay(NOT_SET);
    }
    else if (cardToPlay() == NOT_SET) {
        cardToPlay(id);
    }
    else {
        console.log("CARD to PLAY = " + cardToPlay());
        var el = document.getElementById("card_" + cardToPlay());
        if (el != null && typeof el != 'undefined') {
            el.firstChild.style["WebkitTransform"] = "scale(1.0)";
        }
        cardToPlay(id);
    }

}

function cardClick(id) {
    if (json.state == HAND) {
        if (json.pid == json.turn) {
            showCard(id);
        }
        else {
            setTimeout(function () {
                $(".messageArea").html("");
            }, 3000);
            $(".messageArea").html("Not your turn");
        }
    }
    // Check if the Picker is calling a card Under
    if ((json.state == PICKING) && (json.pid == json.turn) && (json.picked = 1)) {
        var callSuit = $("#suit option:selected").text();

        if (callSuit.indexOf("Under") > -1) {
            // Flip card to back
            consol.log("Picking card Under with id = " + id);
        }
    }
}

function pickBlind() {
    // Set picker
    if (json.pid == json.turn) {
        json.picker = $(".player#P" + json.turn + " #P" + json.turn + "_name")
				.html();
        $(".sidebar .userdata #picker").html(json.picker);
        json.picked = 1;

        // flip blind cards to show
        $.each(json.blind, function (i) {
            var index = i + json.numplaycrd;
            $("#blind #card_" + index + " img").attr("src",
				"img/cards/" + json.blind[i].card + ".png");
        });

        // Change button text to "Discard" and new onclick function
        // Allow drag and drop to discard area and back
        $(".myButtons .pick").html("Discard");
        $(".myButtons .pick").attr('onClick', 'discardBlind();');
        $(".myButtons .pass").hide();
        $(".myButtons .nextHand").hide();
    }
    else {
        setTimeout(function () {
            $(".messageArea").html("");
        }, 3000);
        $(".messageArea").html("Not your turn");
    }

}
function discardBlind() {
    console.log("discard Blind");

    if ($("#blind").children().length != json.numblindcrd) {
        console.log("Need " + json.numblindcrd + " in Blind");
        setTimeout(function () {
            $(".messageArea").html("");
        }, 3000);
        $(".messageArea").html(
				"Need " + json.numblindcrd
						+ " cards in the Blind");

        return;
    }

    if (json.players.length == 5) {
        // Check if you have the called suit in your hand
        var callSuit = $("#suit option:selected").text();
        var found = false;
        console.log("Called Suit = (" + callSuit + ")");

        var myArray = [];
        if (callSuit == "Club") {
            myArray = CLUB;
        }
        else if (callSuit == "Spade") {
            myArray = SPADE;
        }
        else if (callSuit == "Heart") {
            myArray = HEART;
        }
        else {
            // Called suit is "Under"
            found = true;
        }

        var cardArray = $("#my_cards li img").map(function () { return $(this).attr("src"); }).get();
        var playerMessage = "You don't have the called suit in your hand";
        for (var i = 1; i < cardArray.length; i++) {
            var fileNameIndex = cardArray[i].lastIndexOf("/") + 1;
            var filename = cardArray[i].substr(fileNameIndex).slice(0, -4);

            // Check for card under, if filename is "back" and callSuit in "Under" we found a card
            if (filename == "back" && callSuit.indexOf("Under") > -1) {
                found = true;
                break;
            }
            if ($.inArray(filename, myArray) >= 0) {
                // The Ace can't be in the players hand
                if (filename != myArray[5]) {
                    found = true;
                    break;
                }
                else {
                    playerMessage = "You have the Ace in your hand";
                }
            }
        }
        if (!found) {
            setTimeout(function () {
                $(".messageArea").html("");
            }, 3000);
            $(".messageArea").html(playerMessage);
            return;
        }

        if (callSuit.indexOf("Under") == -1) {
            // check for the Ace of the called suit in the blind
            $.each(json.blind, function (i) {
                if (json.blind[i]) {
                    if (json.blind[i].card == myArray[myArray.length - 1]) {
                        found = false;
                    }
                }
            });
        }

        if (!found) {
            setTimeout(function () {
                $(".messageArea").html("");
            }, 3000);
            $(".messageArea").html("You can't discard the Ace for the called suit");
            return;
        }

    }


    var blindObj = {};
    blindObj["playerPicked"] = json.turn;
    blindObj["csuit"] = callSuit;

    var size = $("#blind li").val("[id=^card_]").length;
    for (var i = 0; i < size; i++) {
        // NOTE only takes up to two digit
        var cardId = $("#blind li").val("[id=^card_]")[i].id.substring(5, 7);
        blindObj["blind_" + i] = cardId;
    }
    console.log("stringify blindObj = " + JSON.stringify(blindObj));

    $.post("/pick", $.param(blindObj))
		.done(function (data) {
		    // disable blind
		    $("#blindData").hide();
		    $(".myButtons .pick").hide();
		    $(".myButtons .pass").hide();
		    $(".myButtons .nextHand").hide();
		    $(".sidebar .userdata").show();

		    // Set called suit
		    json.csuit = callSuit; //$("#suit option:selected").text();
		    $(".sidebar .userdata #calledsuit").html(json.csuit);

		    // add up points -- Should this be a server task?
		    var myPoints = json.points;
		    for (var i = 0; i < json.blind.length; i++) {
		        if (json.blind[i]) {
		            var index = $.inArray(json.blind[i].card, cardValue);
		            myPoints += cardPoints[index];
		            console.log(i + " my Points = " + myPoints);
		        }
		    }
		    $("#mypoints").html(myPoints);
		    console.log("my Points = " + myPoints);

		    showStats();
		}
	);
}
function pass() {
    if (json.pid != json.turn) {
        setTimeout(function () {
            $(".messageArea").html("");
        }, 3000);
        $(".messageArea").html("Not your turn");
    }
    else {
        var params = { "playerPass": json.turn };
        $.post("/pass", $.param(params))
			.done(function (data) {

			    console.log("pass");
			    // disable blind
			    $("#blindData").hide();
			    $(".myButtons .pick").hide();
			    $(".myButtons .pass").hide();
			    $(".myButtons .nextHand").hide();
			    $(".sidebar .userdata").show();

			    // Turn off border color
			    $(".player#P" + json.turn).css("border", "0px");

			    // add up points

			    // Set game state
			    document.getElementById("P" + json.turn + "_action").innerHTML = "Passed";

			    console.log("Data = " + data);
			    console.log("calling showStats()")
			    showStats();
			}
	);
    }

}
function gameEnd() {

    $.post("/gameEnd").done(function (data) {

        console.log("End of game move to login page");

        // turn the timer off.
        clearTimeout(timer);

        //current url
        var url = location.href;
        var index = url.indexOf("sheepshead");
        var newUrl = url.substring(0, index);
        location.href = url.substring(0, url.indexOf("sheepshead"));

    });
    return;
}

function nextHand() {

    if (json.pid != json.turn) {
        setTimeout(function () {
            $(".messageArea").html("");
        }, 3000);
        $(".messageArea").html("Not your turn");
    }

    $.post("/nextHand")
		.done(function (data) {

		    console.log("move to next hand");
		    $(".myButtons .nextHand").hide();

		    // turn the timer back on.
		    showStats();
		});

}

function optionChange() {
    var callSuit = $("#suit option:selected").text();

    if (callSuit.indexOf("Under") > -1) {
        // Click you card under.

        playerMessage = "Click your card Under";
        $(".messageArea").html(playerMessage);
    }
}


var dragAndDrop = {

    blindCards: 2,
    playCards: 6,

    init: function () {
        this.dragula();
        this.eventListeners();
    },

    eventListeners: function () {
        this.dragula
				.on(
						'drop',
						function (el, target, source, sibling) {
						    // console.log(el.getElementsByTagName('img')[0].src);
						    // console.log(this);
						    var srcID = el.getAttribute('id');
						    console.log("Event source Card ID = " + srcID);
						    var trgEL = target.getAttribute('id');
						    console.log("Event target element ID = " + trgEL);

						    var srcEL = source.getAttribute('id');
						    console.log("Event source element Card ID = " + srcEL);

						    var trgID;
						    if (sibling) {
						        trgID = sibling.getAttribute('id');
						        //console.log("Event target Card ID = " + trgID);
						    }

						    // if source is blind get the index of the card, see
						    // if we need to add it
						    if ((srcEL == "blind") && (trgEL == "my_cards")) {
						        var index = parseInt(srcID.split("_")[1], 10);
						        console.log("B->C index = " + index);
						        if (index >= json.numplaycrd) {
						            json.mycards[index] = json.blind[index - json.numplaycrd];
						            json.blind[index - json.numplaycrd] = null;

						        }
						        else {
						            json.mycards[index] = json.blind[index + json.numblindcrd];
						            json.blind[index + json.numblindcrd] = null;
						        }

						    }
						    else if ((srcEL == "my_cards")
									&& (trgEL == "blind")) {
						        var index = parseInt(srcID.split("_")[1], 10);
						        console.log("C->B index = (" + index + ")");
						        if (index >= json.numplaycrd) {
						            json.blind[index - json.numplaycrd] = json.mycards[index];
						            json.mycards[index] = null;
						        }
						        else {
						            json.blind[index + json.numblindcrd] = json.mycards[index];
						            json.mycards[index] = null;
						        }
						    }

						    el.removeAttribute("class");
						});

        //console.log("Drop event");
    },

    dragula: function () {
        this.dragula = dragula([document.querySelector('#my_cards'),
				document.querySelector('#blind')], {
				    moves: this.canMove.bind(this),
				    copy: false,
				});
        //console.log("dragula function");
    },

    canMove: function (el, source, target, sibling) {
        var bCnt = $("#blind").children().length;
        var cCnt = $("#my_cards").children().length;
        console.log("canMove - blind count = " + bCnt + ", card count = " + cCnt);

        var srcEL = source.getAttribute('id');
        console.log("canMove - Event source element Card ID = " + srcEL);

        if (((srcEL == "blind") && (bCnt == 1))
				|| ((srcEL == "my_cards") && (cCnt == 1))) {
            return false;
        }
        return true;
    },

    dropped: function (el) {
        console.log("dropped element = " + el);
        if (cardToPlay() != NOT_SET) {
            console.log("reset card_" + cardToPlay());
            var el = document.getElementById("card_" + cardToPlay());
            el.firstChild.style["WebkitTransform"] = "scale(1.0)";

            cardToPlay(NOT_SET);
        }
        console.log("dropped element " + el.getAttribute('id'));

        this.blindCards = $("#blind").children().length;
        this.playCards = $("#my_cards").children().length;

    }

};

